using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/// <summary>
/// Pelaaja
/// </summary>
public class Pelaaja
{
    /// <summary>
    /// Pisteet
    /// </summary>
    public int Pisteet;

    /// <summary>
    /// Nimi
    /// </summary>
    public string Nimi;
}

/// @author Antti-Jussi Lakanen
/// @version 2021
/// 
/// <summary>
/// Bonus 2-3. Heitellään noppaa ja pitää saada 100 pistettä tai enemmän.
/// </summary>
public class NopanHeitto
{
    public static void Main(string[] args)
    {
        const int TAVOITE = 10;

        Random r = new Random();
        // Tässä malliksi kahden pelaajan peli. 
        // Periaatteessa olisi mahdollista laajentaa tätä
        // useamman pelaajankin peliksi hyvinkin helposti. 
        List<Pelaaja> pelaajat = new List<Pelaaja>() {
            new Pelaaja { Nimi = "Pelaaja 1", Pisteet = 0 },
            new Pelaaja { Nimi = "Pelaaja 2", Pisteet = 0 }
        };

        Console.WriteLine("Tervetuloa heittämään noppaa");
        Console.WriteLine("Tavoitteena on saada " + TAVOITE + " pistettä.");
        while (true)
        {
            foreach (var pelaaja in pelaajat)
            {
                Console.WriteLine();
                pelaajat.ForEach(x => Console.WriteLine(x.Nimi + " " + x.Pisteet));
                Console.WriteLine("Vuorossa: " + pelaaja.Nimi);
                pelaaja.Pisteet += Vuoro(pelaaja);
                if (pelaaja.Pisteet >= TAVOITE) break;
                Console.WriteLine("Vuoro vaihtuu");
            }
            if (!pelaajat.TrueForAll(x => x.Pisteet < TAVOITE)) break;
        }

        Console.WriteLine();
        Console.WriteLine("Peli päättyy");
        Console.WriteLine(pelaajat[0].Nimi + ", " + pelaajat[0].Pisteet);
        Console.WriteLine(pelaajat[1].Nimi + ", " + pelaajat[1].Pisteet);
    }

    /// <summary>
    /// Pelin yksi vuoro
    /// </summary>
    /// <param name="pelaaja">Vuorossa oleva pelaaja</param>
    /// <returns></returns>
    public static int Vuoro(Pelaaja pelaaja)
    {
        Random r = new Random();
        int vuoropisteet = 0;

        while (true)
        {
            int arvottu = r.Next(1, 7);

            Console.Write("Valitse: 1 Heitto, 2 Pankki > ");
            if (Console.ReadLine()[0] == '2')
            {
                break;
            }

            Console.WriteLine("Heitit: " + arvottu);

            if (arvottu == 1)
            {
                vuoropisteet = 0;
                break;
            }
            vuoropisteet += arvottu;
            Console.WriteLine("Vuoropisteet: " + vuoropisteet);
        }
        return vuoropisteet;
    }
}